An abstraction representing a unified type for an HistoricalObject and HistoricalArray.

### Type parameters

- #### T

### Hierarchy

- ObservableContainerElement<T>
  - HistoricalContainerElement

### Implemented by

- HistoricalArray
- HistoricalObject

## Index

### Methods

- addListener
- elementAt
- events
- id
- isAttached
- isDetached
- model
- off
- on
- once
- parent
- path
- relativePath
- removeAllListeners
- removeListener
- removeListeners
- toJSON
- type
- value

## Methods

### addListener

- addListener(event: string, listener: ConvergenceEventListener<IConvergenceEvent>): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.addListener

  Adds a new event listener for the specified event. The class will ignore duplicate registrations of the same listener to the same event.

  #### Parameters

  - ##### event: string

    The name of the event to add the listener for.

  - ##### listener: ConvergenceEventListener<IConvergenceEvent>

    The listener callback to register.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### elementAt

- elementAt(path: Path): HistoricalElement<any>
- elementAt(...elements: PathElement[]): HistoricalElement<any>

- Overrides ObservableObject.elementAt

  See HistoricalModel.elementAt

  #### Parameters

  - ##### path: Path

    the query instructions leading to the desired element

  #### Returns HistoricalElement<any>

- Overrides ObservableObject.elementAt

  #### Parameters

  - ##### Rest ...elements: PathElement[]

  #### Returns HistoricalElement<any>

### events

- events(): Observable<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.events

  Provides the events emitted by this object as an Observable stream.

  example

        eventEmitter.events()
          .filter(e => e.name === "myevent")
          .subscribe(e => console.log(e));

  #### Returns Observable<IConvergenceEvent>

  An Observable stream of all events emitted by this object.

### id

- id(): string

- Inherited from ObservableObject.id

  #### Returns string

### isAttached

- isAttached(): boolean

- Inherited from ObservableObject.isAttached

  #### Returns boolean

### isDetached

- isDetached(): boolean

- Inherited from ObservableObject.isDetached

  #### Returns boolean

### model

- model(): ObservableModel

- Inherited from ObservableObject.model

  #### Returns ObservableModel

### off

- off(event: string, listener: ConvergenceEventListener<IConvergenceEvent>): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.off

  Removes a single event listener for a specific event.

  #### Parameters

  - ##### event: string

    The name of the event to remove the listener for.

  - ##### listener: ConvergenceEventListener<IConvergenceEvent>

    The listener callback to unregister.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### on

- on(event: string, listener: ConvergenceEventListener<IConvergenceEvent>): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.on

  Adds a new event listener for the specified event. The class will ignore duplicate registrations of the same listener to the same event.

  #### Parameters

  - ##### event: string

    The name of the event to add the listener for.

  - ##### listener: ConvergenceEventListener<IConvergenceEvent>

    The listener callback to register.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### once

- once(event: string, listener: ConvergenceEventListener<IConvergenceEvent>): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.once

  Adds a single shot event listener for the specified event. The listener will be called the first time the specified event is fired after the event registration occurs, after which the registration will be removed and no further events will be passed to the listener.

  #### Parameters

  - ##### event: string

    The name of the event to add the listener for.

  - ##### listener: ConvergenceEventListener<IConvergenceEvent>

    The listener callback to register.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### parent

- parent(): ObservableContainerElement<any>

- Inherited from ObservableObject.parent

  #### Returns ObservableContainerElement<any>

### path

- path(): Path

- Inherited from ObservableObject.path

  #### Returns Path

### relativePath

- relativePath(): PathElement

- Inherited from ObservableObject.relativePath

  #### Returns PathElement

### removeAllListeners

- removeAllListeners(): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.removeAllListeners

  Removes all listeners for all events. This is useful for cleanup before disposing of this particular event emitter.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### removeListener

- removeListener(event: string, listener: ConvergenceEventListener<IConvergenceEvent>): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.removeListener

  Removes a single event listener for a specific event.

  #### Parameters

  - ##### event: string

    The name of the event to remove the listener for.

  - ##### listener: ConvergenceEventListener<IConvergenceEvent>

    The listener callback to unregister.

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### removeListeners

- removeListeners(event: string): ConvergenceEventEmitter<IConvergenceEvent>

- Inherited from ConvergenceEventEmitter.removeListeners

  Removes all listeners bound on the given event.

  #### Parameters

  - ##### event: string

    the name of the event to remove listeners for

  #### Returns ConvergenceEventEmitter<IConvergenceEvent>

  This object, in support of a fluent API.

### toJSON

- toJSON(): any

- Inherited from ObservableObject.toJSON

  #### Returns any

### type

- type(): string

- Inherited from ObservableObject.type

  #### Returns string

### value

- value(): T

- Inherited from ObservableObject.value

  #### Returns T